<?php
/**
 * PLUGIN INSTALLER
 *
 * Version 0.4
 * Fr Contenido 4.4.4 and up 4.5.x
 *
 * @author      Martin Horwath (horwath@dayside.net)
 * @date        26.09.2004
 * @date        10.10.2005
 * @date        15.02.2006 - Paul Sauer <contenido@saueronline.de>
 * @date        12.09.2006 - Murat Purc <murat@purc.de>
 * @package     Contenido
 * @subpackage  Plugin installer
 */

/* PLUGIN INSTALLER
 * Version 0.4
 * Fr Contenido 4.4.4 and up 4.5.x
 * Autor: Martin Horwath (horwath@dayside.net)
 * Datum: 26.09.2004
 * Modifiziert: 10.10.2005
 *              15.02.2006 - Paul Sauer <contenido@saueronline.de>
 *              12.09.2006 - Murat Purc <murat@purc.de>
 */


$cfg['debug']['installer'] = false;
$checktablestatus = true;


$contenido_path = '../../';
if (file_exists($contenido_path . 'includes/startup.php')) {
    include_once($contenido_path . 'includes/startup.php');
} else {
    include_once($contenido_path . 'includes/config.php');
}

cInclude('includes', 'functions.general.php');

$cfg['debug']['backend_exectime']['fullstart'] = getmicrotime();

cInclude('includes', 'functions.i18n.php');
cInclude('includes', 'functions.api.php');
cInclude('includes', 'functions.general.php');
cInclude('includes', 'functions.database.php');
cInclude('includes', 'functions.str.php');

cInclude('classes', 'class.xml.php');
cInclude('classes', 'class.navigation.php');
cInclude('classes', 'class.template.php');
cInclude('classes', 'class.backend.php');
cInclude('classes', 'class.notification.php');
cInclude('classes', 'class.area.php');
cInclude('classes', 'class.action.php');
cInclude('classes', 'class.layout.php');
cInclude('classes', 'class.treeitem.php');
cInclude('classes', 'class.user.php');
cInclude('classes', 'class.group.php');
cInclude('classes', 'class.cat.php');
cInclude('classes', 'class.client.php');
cInclude('classes', 'class.inuse.php');
cInclude('classes', 'class.table.php');

plugin_include('mod_rewrite', 'includes/functions.mod_rewrite_setup.php');

page_open(array('sess' => 'Contenido_Session', 'auth' => 'Contenido_Challenge_Crypt_Auth', 'perm' => 'Contenido_Perm'));

i18nInit($cfg['path']['contenido'] . $cfg['path']['locale'], $belang);
cInclude('includes', 'cfg_language_de.inc.php');

class DB_Upgrade extends DB_Contenido {/*donut*/}

// instanzen der db_contenido
$db  = new DB_Contenido;
$db2 = new DB_Contenido;

$data['top']         = '';
$data['content']     = '';
$data['bottom']      = '';
$data['body_bottom'] = '';

#$currentuser = new User();
#$currentuser->loadUserByUserID($auth->auth["uid"]);

$cfg["debug"]["backend_exectime"]["start"] = getmicrotime();

if ($checktablestatus) {
    $required_fields = array(
        "idplugin", "name", "version", "author", "idinternal", "url",
        "status", "description", "install", "uninstall", "date"
    );
    
//    $required_table = "DROP TABLE " . $cfg['tab']['plugins'] . ";
    $required_table = "RENAME TABLE " . $cfg['tab']['plugins'] . " TO " . $cfg['tab']['plugins'] . "_" . date('Ymd') . ";
                      CREATE TABLE " . $cfg['tab']['plugins'] . " (
                          idplugin INT(10) NOT NULL default '0',
                          name VARCHAR(60) default NULL,
                          version VARCHAR(10) NOT NULL default '0',
                          author VARCHAR(60) default NULL,
                          idinternal VARCHAR(32) NOT NULL default '0',
                          url TEXT,
                          status INT(10) NOT NULL default '0',
                          description TEXT,
                          install TEXT,
                          uninstall TEXT,
                          date DATETIME NOT NULL default '0000-00-00 00:00:00',
                          PRIMARY KEY (idplugin)
                      ) TYPE=MyISAM;";
    // now we check if the plugin table has the right format...
    msg("Checking status " . $cfg['tab']['plugins']);
    $ptable = $db->metadata($cfg['tab']['plugins']);

    foreach ($ptable as $key) {
        if (!in_array($key['name'], $required_fields)) {
            msg($key['name'] . " (this key can be deleted)", "unused key");
        } else {
            $availableKeys[] = $key['name'];
        }
        $foundkeys[] = $key['name'];
    }
    foreach ($required_fields as $key) {
        if (!in_array($key, $foundkeys)) {
            msg($key . " (this key must be added)", "missing key");
            $missingKeys[] = $key;
        }
    }
    unset ($foundkeys, $key);
    // available elements in table are stored in array -> $availableKeys;
    // missing elements in table are stored in array -> $missingKeys;
    // this is a possible way to handle new versions of plugin installer
    // since this is initial release the table will be dropped and recreated
    // when a missing element is found.
    if (count($missingKeys) > 0) {
        $sql_data = remove_remarks($required_table);
        $sql_pieces = split_sql_file($sql_data, ';');
        msg(count($sql_pieces) . " queries", "Executing:");
        foreach ($sql_pieces as $sqlinit) {
            $db->query($sqlinit);
            msg($sqlinit);
        }
    } else {
        msg("ok");
    }
}

// con_sequence update
updateSequence();

#print '<html><body style="font-family: Verdana; font-size:11px;">';
// installer starts here
#print "<b>PLUGIN INSTALLER</b><br><br>\n";
$data['top'] .= "<b>PLUGIN INSTALLER</b><br><br>\n";

$clink = "<br><a href=\"../../index.php?contenido=$contenido\">Switch to backend</a>\r\n";

if ($installsql = file_get_contents('install.sql')) {
    // get info from sql file
    if (preg_match ("/####(.*)####/i", $installsql, $pinfo)) {
        $pinfo = explode (";", $pinfo[1]);
        // take some nice names easier to work with...
        $pname       = $pinfo[0];
        $pversion    = $pinfo[1];
        $pauthor     = $pinfo[2];
        $pinternalid = $pinfo[3];

        unset($pinfo);
        // first show info
        $data['content'] .= "Plugin Name: " . $pname . "<br>\n";
        $data['content'] .= "Plugin Version: " . $pversion . "<br>\n";
        $data['content'] .= "Author: " . $pauthor . "<br>\n";
        $data['content'] .= "Internal ID: " . $pinternalid . "<br>\n";
        // the user don't need this info...
        $installsql = preg_replace ("/####(.*)####/i", "", $installsql);

        $pstatus = true;
    } else {
        $data['content'] .= "Info missing. First line of install.sql should include following line:<br>";
        $data['content'] .= "<b>####NAME;VERSION;AUTHOR;INTERNAL_ID####</b><br>";
        $data['content'] .= "No further action takes place<br>";

        $pstatus = false;
    }

    // check if idinternal is allready available in table
    $sql = "SELECT * FROM " . $cfg["tab"]["plugins"] . " WHERE idinternal='" . $pinternalid . "';";
    $db->query($sql);
    if ($db->next_record()) {
        $mode     = "update";
        $message .= "Plugin with this internal id allready exists in table.<br>\n";
        if ($pversion == $db->f('version')) {
            $message .= "This version is allready installed.<br>\n";
            $mode     = "uninstall";
        } else {
            $message .= "Switching to upgrade mode.<br>\n";
        }
        $pluginid = $db->f('idplugin');
    } else {
        $mode     = "install";
        $message .= "No plugin with this internal id exists in table.<br>\n";
        $pluginid = false;
    }

    if (!$install && !$uninstall) {
        $data['content'] .= "<br>" . $message;
    }

    if (!$install && $mode == "update") {
        $data['content'] .= "<br><a href=$PHP_SELF?install=1&contenido=$contenido>Update $pname $pversion</a></br>";
    }

    if (!$install && $mode == "install") {
        $data['content'] .= "<br><a href=$PHP_SELF?install=1&contenido=$contenido>Install $pname $pversion</a></br>";
    }

    if (!$uninstall && $mode == "uninstall") {
        $data['content'] .= "<br><a href=$PHP_SELF?uninstall=1&contenido=$contenido>UnInstall $pname $pversion</a></br>";
    }

    if ($uninstall && $pluginid) {
        $sql = "SELECT uninstall FROM " . $cfg["tab"]["plugins"] . " WHERE idplugin='" . $pluginid . "'";
        msg($sql);
        $db->query($sql);
        $db->next_record();

        $uninstallsql = $db->f('uninstall');
        $sql_data     = remove_remarks($uninstallsql);
        $sql_pieces   = split_sql_file($sql_data, ';');

        msg(count($sql_pieces)." queries", "Executing:");
        foreach ($sql_pieces as $sqlinit) {
            $db->query($sqlinit);
            msg($sqlinit);
        }

        uninstallModRewrite();
        
        $data['content'] .= "<br><b>Uninstall complete.</b><br>\r\n";
    }

    if ($pstatus && $install) {
        if ($mode == "install") { // insert all data from install.sql
            $pluginid = $db->nextid($cfg["tab"]["plugins"]); // get next free id using phplib method

            $PID = 100 + $pluginid; // generate !PID! replacement
            $replace = array('!PREFIX!' => $cfg['sql']['sqlprefix'], '!PID!' => $PID);

            $installsql = strtr($installsql, $replace);

            $sql = "INSERT INTO " . $cfg["tab"]["plugins"] . " (idplugin,name,`version`,author,idinternal,`status`,`date`) VALUES ('" . $pluginid . "','" . $pname . "','" . $pversion . "','" . $pauthor . "','" . $pinternalid . "','0','" . date("Y-m-d H:i:s") . "');";
            $uninstallsql = "DELETE FROM " . $cfg["tab"]["plugins"] . " WHERE idplugin='" . $pluginid . "';\r\n";
            msg($sql, "Insert statement for plugin: ");
            $db->query($sql);

            msg ($installsql, "Install query:");

            $sql_data = remove_remarks($installsql);
            $sql_pieces = split_sql_file($sql_data, ';');
            msg(count($sql_pieces) . " queries", "Executing:");
            foreach ($sql_pieces as $sqlinit) {
                // $sqlinit = strtr($sqlinit, $replace);
                // create uninstall.sql for each insert entry
                if (preg_match("/INSERT\s+INTO\s+(.*)\s+VALUES\s*\([\"'\s]*(\d+)/i", $sqlinit, $tmpsql)) {
                    $tmpidname = $db->metadata(trim(str_replace("`", "", $tmpsql[1])));
                    $tmpidname = $tmpidname[0]['name'];
                    $uninstallsql = "DELETE FROM " . trim($tmpsql[1]) . " WHERE " . $tmpidname . "='" . trim($tmpsql[2]) . "';\r\n" . $uninstallsql;
                }

                $db->query($sqlinit);
                msg($sqlinit);
            }

            if ($uninstallsqlfile = file_get_contents('uninstall.sql')) {
                $uninstallsqlfile = remove_remarks($uninstallsqlfile); // remove all comments

                $uninstallsql .= strtr($uninstallsqlfile, $replace); // add to generated sql
                $data['content'] .= "I found uninstall.sql in " . dirname(__FILE__) . "<br>Statements added to uninstall query.<br>\n";
            }

            msg ($uninstallsql, "Uninstall query:");

            $sql = "UPDATE " . $cfg["tab"]["plugins"] . " SET install=0x" . bin2hex($installsql) . ", uninstall=0x" . bin2hex($uninstallsql) . " WHERE (idplugin='" . $pluginid . "');";
            msg($sql, "un/install statements stored");
            $db->query($sql);

            upgradeModRewrite();
            
            $data['content'] .= "<br><b>Install complete.</b><br>\r\n";
        }

        if ($mode == "update") {
            $sql  = "UPDATE " . $cfg["tab"]["plugins"] . " SET\n";
            $sql .= " version = '" . $pversion . "'\n";
            $sql .= "WHERE (idplugin='" . $pluginid . "');";
            msg($sql, "Store new plugin version: ");
            $db->query($sql);
            if ($updatesqlfile = @file_get_contents('update.sql')) {
                $sql = "SELECT uninstall FROM " . $cfg["tab"]["plugins"] . " WHERE idplugin='" . $pluginid . "'";
                msg($sql, "Getting stored uninstall statements: ");
                $db->query($sql);
                $db->next_record();

                $uninstallsql = $db->f('uninstall');
                $updatesqlfile = remove_remarks($updatesqlfile); // remove all comments

                $data['content'] .= "I found update.sql in " . dirname(__FILE__) . "<br>\n";

                $PID = 100 + $pluginid; // generate !PID! replacement
                $replace = array('!PREFIX!' => $cfg['sql']['sqlprefix'], '!PID!' => $PID);
                $updatesql .= strtr($updatesqlfile, $replace); // add to generated sql

                $sql_pieces = split_sql_file($updatesql, ';');
                msg(count($sql_pieces) . " queries", "Executing:");
                foreach ($sql_pieces as $sqlinit) {
                    // $sqlinit = strtr($sqlinit, $replace);
                    // create uninstall.sql for each insert entry
                    if (preg_match("/INSERT\s+INTO\s+(.*)\s+VALUES\s*\([\"'\s]*(\d+)/i", $sqlinit, $tmpsql)) {
                        $tmpidname    = $db->metadata(trim(str_replace("`", "", $tmpsql[1])));
                        $tmpidname    = $tmpidname[0]['name'];
                        $uninstallsql = "DELETE FROM " . trim($tmpsql[1]) . " WHERE " . $tmpidname . "='" . trim($tmpsql[2]) . "';\r\n" . $uninstallsql;
                    } else if (preg_match("/REPLACE \s+INTO\s+(.*)\s+VALUES\s*\([\"'\s]*(\d+)/i", $sqlinit, $tmpsql)) {
                        $tmpidname    = $db->metadata(trim(str_replace("`", "", $tmpsql[1])));
                        $tmpidname    = $tmpidname[0]['name'];
                        $uninstallsql = "DELETE FROM " . trim($tmpsql[1]) . " WHERE " . $tmpidname . "='" . trim($tmpsql[2]) . "';\r\n" . $uninstallsql;
                    }

                    $db->query($sqlinit);
                    msg($sqlinit);
                }
                $sql = "UPDATE " . $cfg["tab"]["plugins"] . " SET uninstall = 0x" . bin2hex($uninstallsql) . " WHERE (idplugin='" . $pluginid . "');";
                msg($sql, "New uninstall statements stored: ");
                $db->query($sql);
            }

            upgradeModRewrite();
            
            $data['content'] .= "<br><b>Update complete.</b><br>\r\n";
        }

        // con_sequence update
        updateSequence();
    }
} else {
    $data['content'] .= "Sorry i found no install.sql in " . dirname(__FILE__) . "<br>\n";
}


// print $clink;
showmsg();

#print '</body></html>';

$cfg["debug"]["backend_exectime"]["end"] = getmicrotime();

if ($cfg["debug"]["rendering"] == true) {
    $data['body_bottom'] .= "Rendering this page took: " . ($cfg["debug"]["backend_exectime"]["end"] - $cfg["debug"]["backend_exectime"]["start"]) . " seconds<br>";
    $data['body_bottom'] .= "Building the complete page took: " . ($cfg["debug"]["backend_exectime"]["end"] - $cfg["debug"]["backend_exectime"]["fullstart"]) . " seconds<br>";

    if (function_exists("memory_get_usage")) {
        $data['body_bottom'] .= "Include memory usage: " . human_readable_size(memory_get_usage() - $cfg["debug"]["oldmemusage"]) . "<br>";
        $data['body_bottom'] .= "Complete memory usage: " . human_readable_size(memory_get_usage()) . "<br>";
    }
}


page_close();


####################################################################################################
##### Output

echo <<<HTML
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
<head>
    <title>Plugin installer</title>
</head>
<body style="font-family:verdana;font-size:11px;">
<form name="client_properties" method="post" action="$PHP_SELF">
    <input type="hidden" name="contenido" value="$contenido">
{$data['top']}<br>
{$data['content']}
{$data['bottom']}
</form>
{$data['body_bottom']}
</body>
</html>
HTML;


####################################################################################################
##### Functions

// some functions to work with...
/**
 * removes '# blabla...' from the mysql_dump.
 * This function was originally developed for phpbb 2.01
 * (C) 2001 The phpBB Group http://www.phpbb.com
 *
 * @return string input_without_#
 */
function remove_remarks($sql) {
    $lines = explode("\n", $sql);
    // try to keep mem. use down
    $sql = "";

    $linecount = count($lines);
    $output = "";

    for ($i = 0; $i < $linecount; $i++) {
        if (($i != ($linecount - 1)) || (strlen($lines[$i]) > 0)) {
            $output .= ($lines[$i][0] != "#")  ? $lines[$i]."\n" : "\n";

            // Trading a bit of speed for lower mem. use here.
            $lines[$i] = "";
        }
    }
    return $output;
}

/**
 * Splits sql- statements into handy pieces.
 * This function was original developed for the phpbb 2.01
 * (C) 2001 The phpBB Group http://www.phpbb.com
 *
 * @return array sql_pieces
 */
function split_sql_file($sql, $delimiter) {
  // Split up our string into "possible" SQL statements.
  $tokens = explode($delimiter, $sql);
  // try to save mem.
  $sql = "";
  $output = array();
  // we don't actually care about the matches preg gives us.
  $matches = array();
  // this is faster than calling count($oktens) every time thru the loop.
  $token_count = count($tokens);
  for ($i = 0; $i < $token_count; $i++) {
    // Dont wanna add an empty string as the last thing in the array.
    if (($i != ($token_count - 1)) || (strlen($tokens[$i] > 0))) {
      // This is the total number of single quotes in the token.
      $total_quotes = preg_match_all("/'/", $tokens[$i], $matches);
      // Counts single quotes that are preceded by an odd number of backslashes,
      // which means they're escaped quotes.
      $escaped_quotes = preg_match_all("/(?<!\\\\)(\\\\\\\\)*\\\\'/", $tokens[$i], $matches);

      $unescaped_quotes = $total_quotes - $escaped_quotes;
      // If the number of unescaped quotes is even, then the delimiter did NOT occur inside a string literal.
      if (($unescaped_quotes % 2) == 0) {
        // It's a complete sql statement.
        $output[] = $tokens[$i];
        // save memory.
        $tokens[$i] = "";
      } else {
        // incomplete sql statement. keep adding tokens until we have a complete one.
        // $temp will hold what we have so far.
        $temp = $tokens[$i] . $delimiter;
        // save memory..
        $tokens[$i] = "";
        // Do we have a complete statement yet?
        $complete_stmt = false;

        for ($j = $i + 1; (!$complete_stmt && ($j < $token_count)); $j++) {
          // This is the total number of single quotes in the token.
          $total_quotes = preg_match_all("/'/", $tokens[$j], $matches);
          // Counts single quotes that are preceded by an odd number of backslashes,
          // which means theyre escaped quotes.
          $escaped_quotes = preg_match_all("/(?<!\\\\)(\\\\\\\\)*\\\\'/", $tokens[$j], $matches);

          $unescaped_quotes = $total_quotes - $escaped_quotes;

          if (($unescaped_quotes % 2) == 1) {
            // odd number of unescaped quotes. In combination with the previous incomplete
            // statement(s), we now have a complete statement. (2 odds always make an even)
            $output[] = $temp . $tokens[$j];
            // save memory.
            $tokens[$j] = "";
            $temp = "";
            // exit the loop.
            $complete_stmt = true;
            // make sure the outer loop continues at the right point.
            $i = $j;
          } else {
            // even number of unescaped quotes. We still dont have a complete statement.
            // (1 odd and 1 even always make an odd)
            $temp .= $tokens[$j] . $delimiter;
            // save memory.
            $tokens[$j] = "";
          }
        } // for..
      } // else
    }
  }
  return $output;
}
// simple function to update con_sequence
function updateSequence($table = false) {
    global $db, $cfg;
    if (!$table) {
        $sql = "SHOW TABLES";
        $db->query($sql);
        while ($db->next_record()) {
            dbUpdateSequence($cfg['sql']['sqlprefix'] . "_sequence", $db->f(0));
        }
    } else {
        dbUpdateSequence($cfg['sql']['sqlprefix'] . "_sequence", $table);
    }
}
// read out next free id * deprecated
function getSequenceId($table) {
    global $db2, $cfg;
    $sql = "SELECT nextid FROM " . $cfg['sql']['sqlprefix'] . "_sequence" . " where seq_name = '$table'";
    $db2->query($sql);
    if ($db2->next_record()) {
        return ($db2->f("nextid") + 1);
    } else {
        msg($table, "missing in " . $cfg['sql']['sqlprefix'] . "_sequence");
        return 0;
    }
}
// debug functions
function msg($value, $info = false) {
    global $cfg;
    if (trim($cfg["debug"]["messages"]) == "") $cfg["debug"]["messages"] = "<br><b>DEBUG:</b>";
    if (!$cfg["debug"]["installer"]) {
        return;
    }
    if ($info) {
        $cfg["debug"]["messages"] .= "<b>$info</b> -> ";
    }
    if (is_array($value)) {
        ob_start();
        print_r($value);
        $output = ob_get_contents();
        ob_end_clean();
        $cfg["debug"]["messages"] .= "<pre>" . htmlspecialchars($output) . "</pre>";
    } else {
        $cfg["debug"]["messages"] .= htmlspecialchars($value) . "<br>";
    }
}

function showmsg() {
    global $cfg;
    if ($cfg["debug"]["installer"]) {
        print "<div style=\"font-family: Verdana, Arial, Helvetica, Sans-Serif; font-size: 11px; color: #000000\">";
        print $cfg["debug"]["messages"];
        print "</div>";
    }
}


/**
 * isWriteable:
 * Checks if a specific file is writeable. Includes a PHP 4.0.4
 * workaround where is_writable doesn't return a value of type
 * boolean. Also clears the stat cache and checks if the file
 * exists.
 * 
 * Copied from /setup/lib/functions.filesystem.php
 * 
 * @param $file string	Path to the file, accepts absolute and relative files
 * @return boolean true if the file exists and is writeable, false otherwise
 */
function isWriteable($file) {
	clearstatcache();
	if (!file_exists($file)) {
		return false;
	}
	
	$bStatus = is_writable($file);
	/* PHP 4.0.4 workaround */
	settype($bStatus, "boolean");
	
	return $bStatus;
}


function copyFile($source, $destination, $backupName=null) {
    global $cfg;
    
    // check source and destination, allow filesystem processes only inside htdocs
    if (strpos($source, $cfg['path']['frontend']) === false) {
        return false;
    } elseif (strpos($destination, $cfg['path']['frontend']) === false) {
        return false;
    } elseif (isset($backupName) && strpos($backupName, $cfg['path']['frontend']) === false) {
        return false;
    }
    
    if ($backupName !== null) {
        if (!rename($destination, $backupName)) {
            return false;
        }
    }
    
    if (!copy($source, $destination . '.bak')) {
        return false;
    }
    
    return true;
}
